//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
#include "main.h"

//------------------------------------------------------------------------------
// ext Action
//------------------------------------------------------------------------------
void do_keyb(char *ktext)
{
	int sl;
	char bst;
//	g_print("%s\n",ktext);
	sl = strlen(ktext);
	keyboard_string_len=strlen(keyboard_string);
	if ((sl > 2) && (keyboard_string_len > 2))
	{
		keyboard_string[keyboard_string_len - 2 ] = keyboard_string[keyboard_string_len - 1 ];
		keyboard_string[keyboard_string_len - 1 ] = 0;
	}

	if ((sl == 1) && (keyboard_string_len < 30))
	{
		bst = ktext[0];
		if((bst != '-') || (keyboard_string_len > 2))
		{
			if((key_caps == 0) && (bst > 64) && (bst < 93))
			{
				bst+=32;
			}
			keyboard_string[keyboard_string_len ] = keyboard_string[keyboard_string_len - 1 ];
			keyboard_string[keyboard_string_len - 1 ] = bst;
			keyboard_string[keyboard_string_len + 1 ] = 0;
		}
	}



	keyboard_string_len=strlen(keyboard_string);
	gtk_label_set_text(GTK_LABEL(keyboard_text),keyboard_string);
}

//------------------------------------------------------------------------------
// key functions
//------------------------------------------------------------------------------
void keyb_0( GtkWidget *widget,gpointer   data )
{
	do_keyb("0");
}

void keyb_1( GtkWidget *widget,gpointer   data )
{
	do_keyb("1");
}

void keyb_2( GtkWidget *widget,gpointer   data )
{
	do_keyb("2");
}

void keyb_3( GtkWidget *widget,gpointer   data )
{
	do_keyb("3");
}

void keyb_4( GtkWidget *widget,gpointer   data )
{
	do_keyb("4");
}

void keyb_5( GtkWidget *widget,gpointer   data )
{
	do_keyb("5");
}

void keyb_6( GtkWidget *widget,gpointer   data )
{
	do_keyb("6");
}

void keyb_7( GtkWidget *widget,gpointer   data )
{
	do_keyb("7");
}

void keyb_8( GtkWidget *widget,gpointer   data )
{
	do_keyb("8");
}

void keyb_9( GtkWidget *widget,gpointer   data )
{
	do_keyb("9");
}

void keyb_A( GtkWidget *widget,gpointer   data )
{
	do_keyb("A");
}

void keyb_B( GtkWidget *widget,gpointer   data )
{
	do_keyb("B");
}

void keyb_C( GtkWidget *widget,gpointer   data )
{
	do_keyb("C");
}

void keyb_D( GtkWidget *widget,gpointer   data )
{
	do_keyb("D");
}

void keyb_E( GtkWidget *widget,gpointer   data )
{
	do_keyb("E");
}

void keyb_F( GtkWidget *widget,gpointer   data )
{
	do_keyb("F");
}

void keyb_G( GtkWidget *widget,gpointer   data )
{
	do_keyb("G");
}

void keyb_H( GtkWidget *widget,gpointer   data )
{
	do_keyb("H");
}

void keyb_I( GtkWidget *widget,gpointer   data )
{
	do_keyb("I");
}

void keyb_J( GtkWidget *widget,gpointer   data )
{
	do_keyb("J");
}

void keyb_K( GtkWidget *widget,gpointer   data )
{
	do_keyb("K");
}

void keyb_L( GtkWidget *widget,gpointer   data )
{
	do_keyb("L");
}

void keyb_M( GtkWidget *widget,gpointer   data )
{
	do_keyb("M");
}

void keyb_N( GtkWidget *widget,gpointer   data )
{
	do_keyb("N");
}

void keyb_O( GtkWidget *widget,gpointer   data )
{
	do_keyb("O");
}

void keyb_P( GtkWidget *widget,gpointer   data )
{
	do_keyb("P");
}

void keyb_Q( GtkWidget *widget,gpointer   data )
{
	do_keyb("Q");
}

void keyb_R( GtkWidget *widget,gpointer   data )
{
	do_keyb("R");
}

void keyb_S( GtkWidget *widget,gpointer   data )
{
	do_keyb("S");
}

void keyb_T( GtkWidget *widget,gpointer   data )
{
	do_keyb("T");
}

void keyb_U( GtkWidget *widget,gpointer   data )
{
	do_keyb("U");
}

void keyb_V( GtkWidget *widget,gpointer   data )
{
	do_keyb("V");
}

void keyb_W( GtkWidget *widget,gpointer   data )
{
	do_keyb("W");
}

void keyb_X( GtkWidget *widget,gpointer   data )
{
	do_keyb("X");
}

void keyb_Y( GtkWidget *widget,gpointer   data )
{
	do_keyb("Y");
}

void keyb_Z( GtkWidget *widget,gpointer   data )
{
	do_keyb("Z");
}

void keyb_minus( GtkWidget *widget,gpointer   data )
{
	do_keyb("-");
}


void keyb_rubout( GtkWidget *widget,gpointer   data )
{
	do_keyb("RUB");
}


void keyb_caps( GtkWidget *widget,gpointer   data )
{
	int ii;
	key_caps +=1;
	key_caps &=1;
	if(key_caps == 0)
	{
		gtk_pixmap_set(GTK_PIXMAP(key_pixwid[39]),key_pixmap[39],key_mask[39]);
		for(ii=10;ii<36;ii++)
		{
			gtk_pixmap_set(GTK_PIXMAP(key_pixwid[ii]),key_pixmap[ii],key_mask[ii]);
		}
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP(key_pixwid[39]),key_pixmap[40],key_mask[40]);
		for(ii=10;ii<36;ii++)
		{
			gtk_pixmap_set(GTK_PIXMAP(key_pixwid[ii]),key_pixmap[ii+40],key_mask[ii+40]);
		}
	}
}

